MODULE Classes;

IMPORT
  SYSTEM, W := Windows;

TYPE
  Char         = W.Char;
  Boolean      = W.Boolean;
  ShortInt     = W.ShortInt;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Shortreal    = W.Shortreal;
  Real         = W.Real;
  Set	       = W.Set;
  String       = W.String;

TYPE
  TList*       = POINTER TO RECORD
    left   : TList;
    right  : TList;
    name   : String;
    sys    : Boolean;
    count* : Integer;

    PROCEDURE & Init*;
    BEGIN
      left    := NIL;
      right   := NIL;
      name    := "";
      count   := 0;
    END Init;

    PROCEDURE Add*(name: String; sys: Boolean);
    VAR
      ob0, ob1: TList;
      left: Boolean;
      res: String;
    BEGIN

      ob0 := SELF;
      ob1 := ob0.right;
      left := FALSE;

      res := UpperCase(name);

      LOOP
        IF ob1 # NIL THEN
          IF res < ob1.name THEN
	    ob0 := ob1;
	    ob1 := ob0.left;
	    left := TRUE
          ELSIF res > ob1.name THEN
	    ob0 := ob1;
	    ob1 := ob0.right;
	    left := FALSE
          ELSE
            EXIT
          END;
        ELSE (*insert*)
          NEW(ob1);
          IF left THEN
	    ob0.left := ob1
          ELSE
	    ob0.right := ob1
          END;
          ob1.left:=NIL;
          ob1.right:=NIL;
          ob1.name := res;
          ob1.sys := sys;
          INC(count);
          EXIT;
        END;
      END;

    END Add;

    PROCEDURE Find*(name: String): Boolean;
    VAR
      obj: TList;
      res: String;
    BEGIN
      res := UpperCase(name);
      obj := SELF;
      LOOP
        IF obj # NIL THEN
          IF res < obj.name THEN
	    obj := obj.left;
          ELSIF res > obj.name THEN
	    obj := obj.right;
          ELSE (*ok*)
            EXIT
          END;
        ELSE (*no found*)
          RETURN FALSE;
        END;
      END;
      RETURN TRUE;
    END Find;

    PROCEDURE UnregisterAllClass*;

      PROCEDURE Show(VAR obj: TList);
      BEGIN
        IF obj = NIL THEN RETURN END;
        IF obj.left  # NIL THEN Show(obj.left); END;
        IF obj.right # NIL THEN Show(obj.right); END;
        IF ~obj.sys THEN W.UnregisterClass(obj.name,W.hInstance); END;
      END Show;

    BEGIN
      Show(left);
      Show(right);
    END UnregisterAllClass;

    PROCEDURE ShowClass*;

      PROCEDURE Show(VAR obj: TList);
      BEGIN
        IF obj = NIL THEN RETURN END;
        IF obj.left  # NIL THEN Show(obj.left); END;
        IF obj.right # NIL THEN Show(obj.right); END;
        W.MessageBox(0,obj.name,"",{});
      END Show;

    BEGIN
      Show(left);
      Show(right);
    END ShowClass;

  END;

(*##################################################*)

PROCEDURE Length*(name: String): Integer;
VAR
  i: Integer;
BEGIN
  i:=0;
  WHILE  (name[i] # 0X) DO INC(i) END;
  RETURN i;
END Length;

PROCEDURE UpperCase*(name: String): String;
VAR
  res: String;
  i: Integer;
BEGIN
  i:=0;
  WHILE  (name[i] # 0X) DO
    CASE name[i] OF
      "a".."z": res[i] := CAP(name[i]);
    ELSE
      res[i] := name[i];
    END;
    INC(i);
    res[i] := 0X;
  END;
  RETURN res;
END UpperCase;

PROCEDURE IntToStr* (x: LONGINT): String;
VAR
  j, k: INTEGER; ch: CHAR; a: ARRAY 32 OF CHAR;
  s: String;
BEGIN
  IF x # MIN(LONGINT) THEN
    IF x < 0 THEN s[0] := "-"; k := 1; x := -x ELSE k := 0 END;
    j := 0; REPEAT a[j] := CHR(x MOD 10 + ORD("0")); x := x DIV 10; INC(j) UNTIL x = 0
  ELSE
    a := "8085774586302733229";
    s[0] := "-";
    k := 1;
    j := 0; WHILE a[j] # 0X DO INC(j) END
  END;
  ASSERT(k + j < LEN(s), 23);
  REPEAT DEC(j); ch := a[j]; s[k] := ch; INC(k) UNTIL j = 0;
  s[k] := 0X;
  RETURN s;
END IntToStr;

(*##################################################*)
(*##################################################*)
(*##################################################*)

 VAR
  result     : Integer;
  ClassList* : TList;

BEGIN
  NEW(ClassList);

  ClassList.Add("Button"	    ,TRUE);
  ClassList.Add("ComboBox"	    ,TRUE);
  ClassList.Add("Edit"		    ,TRUE);
  ClassList.Add("ListBox"	    ,TRUE);
  ClassList.Add("MDIClient"	    ,TRUE);
  ClassList.Add("ScrollBar"	    ,TRUE);
  ClassList.Add("Static"	    ,TRUE);

  ClassList.Add("ToolbarWindow32"   ,TRUE);
  ClassList.Add("ReBarWindow32"	    ,TRUE);
  ClassList.Add("ComboBoxEx32"	    ,TRUE);
  ClassList.Add("tooltips_class32"  ,TRUE);

  ClassList.Add("SysListView32"	    ,TRUE);
  ClassList.Add("SysTreeView32"	    ,TRUE);
  ClassList.Add("SysHeader32"	    ,TRUE);
  ClassList.Add("SysTabControl32"   ,TRUE);
  ClassList.Add("SysAnimate32"	    ,TRUE);
  ClassList.Add("SysMonthCal32"	    ,TRUE);
  ClassList.Add("SysDateTimePick32" ,TRUE);
  ClassList.Add("SysIPAddress32"    ,TRUE);

  ClassList.Add("msctls_statusbar32",TRUE);
  ClassList.Add("msctls_trackbar32" ,TRUE);
  ClassList.Add("msctls_updown32"   ,TRUE);
  ClassList.Add("msctls_progress32" ,TRUE);
  ClassList.Add("msctls_hotkey32"   ,TRUE);

END Classes.
