MODULE Graphics;

IMPORT
  SYSTEM, W:=Windows, I := Images;

TYPE
  Byte         = W.Byte;
  Char         = W.Char;
  Boolean      = W.Boolean;
  SmallInt     = W.SmallInt;
  ShortInt     = W.ShortInt;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Shortreal    = W.Shortreal;
  Real         = W.Real;
  Set	       = W.Set;
  String       = W.String;

CONST
  fsBold*                          = 1;
  fsItalic*                        = 2;
  fsUnderline*                     = 3;
  fsStrikeOut*                     = 4;

  bsSolid*                         = 10;
  bsClear*                         = 11;
  bsHorizontal*                    = 0;
  bsVertical*                      = 1;
  bsFDiagonal*                     = 2;
  bsBDiagonal*                     = 3;
  bsCross*                         = 4;
  bsDiagCross*                     = 5;

  psSolid*                         = 0;
  psDash*                          = 1;
  psDot*                           = 2;
  psDashDot*                       = 3;
  psDashDotDot*                    = 4;
  psClear*                         = 5;
  psInsideFrame*                   = 6;
  psUserStyle*                     = 7;
  psAlternate*                     = 8;

  clBlack*                         = 0000000H;
  clMaroon*                        = 0000080H;
  clGreen*                         = 0008000H;
  clOlive*                         = 0008080H;
  clNavy*                          = 0800000H;
  clPurple*                        = 0800080H;
  clTeal*                          = 0808000H;
  clGray*                          = 0808080H;
  clSilver*                        = 0C0C0C0H;
  clRed*                           = 00000FFH;
  clLime*                          = 000FF00H;
  clYellow*                        = 000FFFFH;
  clBlue*                          = 0FF0000H;
  clFuchsia*                       = 0FF00FFH;
  clAqua*                          = 0FFFF00H;
  clLtGray*                        = 0C0C0C0H;
  clDkGray*                        = 0808080H;
  clWhite*                         = 0FFFFFFH;
  StandardColorsCount*             = 16;

  clMoneyGreen*                    = 0C0DCC0H;
  clSkyBlue*                       = 0F0CAA6H;
  clCream*                         = 0F0FBFFH;
  clMedGray*                       = 0A4A0A0H;
  ExtendedColorsCount*             = 4;

  clNone*                          = 01FFFFFFFH;
  clDefault*                       = 020000000H;


  clWebSnow*                       = 0FAFAFFH;
  clWebFloralWhite*                = 0F0FAFFH;
  clWebLavenderBlush*              = 0F5F0FFH;
  clWebOldLace*                    = 0E6F5FDH;
  clWebIvory*                      = 0F0FFFFH;
  clWebCornSilk*                   = 0DCF8FFH;
  clWebBeige*                      = 0DCF5F5H;
  clWebAntiqueWhite*               = 0D7EBFAH;
  clWebWheat*                      = 0B3DEF5H;
  clWebAliceBlue*                  = 0FFF8F0H;
  clWebGhostWhite*                 = 0FFF8F8H;
  clWebLavender*                   = 0FAE6E6H;
  clWebSeashell*                   = 0EEF5FFH;
  clWebLightYellow*                = 0E0FFFFH;
  clWebPapayaWhip*                 = 0D5EFFFH;
  clWebNavajoWhite*                = 0ADDEFFH;
  clWebMoccasin*                   = 0B5E4FFH;
  clWebBurlywood*                  = 087B8DEH;
  clWebAzure*                      = 0FFFFF0H;
  clWebMintcream*                  = 0FAFFF5H;
  clWebHoneydew*                   = 0F0FFF0H;
  clWebLinen*                      = 0E6F0FAH;
  clWebLemonChiffon*               = 0CDFAFFH;
  clWebBlanchedAlmond*             = 0CDEBFFH;
  clWebBisque*                     = 0C4E4FFH;
  clWebPeachPuff*                  = 0B9DAFFH;
  clWebTan*                        = 08CB4D2H;

  clWebYellow*                     = 000FFFFH;
  clWebDarkOrange*                 = 0008CFFH;
  clWebRed*                        = 00000FFH;
  clWebDarkRed*                    = 000008BH;
  clWebMaroon*                     = 0000080H;
  clWebIndianRed*                  = 05C5CCDH;
  clWebSalmon*                     = 07280FAH;
  clWebCoral*                      = 0507FFFH;
  clWebGold*                       = 000D7FFH;
  clWebTomato*                     = 04763FFH;
  clWebCrimson*                    = 03C14DCH;
  clWebBrown*                      = 02A2AA5H;
  clWebChocolate*                  = 01E69D2H;
  clWebSandyBrown*                 = 060A4F4H;
  clWebLightSalmon*                = 07AA0FFH;
  clWebLightCoral*                 = 08080F0H;
  clWebOrange*                     = 000A5FFH;
  clWebOrangeRed*                  = 00045FFH;
  clWebFirebrick*                  = 02222B2H;
  clWebSaddleBrown*                = 013458BH;
  clWebSienna*                     = 02D52A0H;
  clWebPeru*                       = 03F85CDH;
  clWebDarkSalmon*                 = 07A96E9H;
  clWebRosyBrown*                  = 08F8FBCH;

  clWebPaleGoldenrod*              = 0AAE8EEH;
  clWebLightGoldenrodYellow*       = 0D2FAFAH;
  clWebOlive*                      = 0008080H;
  clWebForestGreen*                = 0228B22H;
  clWebGreenYellow*                = 02FFFADH;
  clWebChartreuse*                 = 000FF7FH;
  clWebLightGreen*                 = 090EE90H;
  clWebAquamarine*                 = 0D4FF7FH;
  clWebSeaGreen*                   = 0578B2EH;
  clWebGoldenRod*                  = 020A5DAH;
  clWebKhaki*                      = 08CE6F0H;
  clWebOliveDrab*                  = 0238E6BH;
  clWebGreen*                      = 0008000H;
  clWebYellowGreen*                = 032CD9AH;
  clWebLawnGreen*                  = 000FC7CH;
  clWebPaleGreen*                  = 098FB98H;
  clWebMediumAquamarine*           = 0AACD66H;
  clWebMediumSeaGreen*             = 071B33CH;
  clWebDarkGoldenRod*              = 00B86B8H;
  clWebDarkKhaki*                  = 06BB7BDH;
  clWebDarkOliveGreen*             = 02F6B55H;
  clWebDarkgreen*                  = 0006400H;
  clWebLimeGreen*                  = 032CD32H;
  clWebLime*                       = 000FF00H;
  clWebSpringGreen*                = 07FFF00H;
  clWebMediumSpringGreen*          = 09AFA00H;
  clWebDarkSeaGreen*               = 08FBC8FH;

  clWebLightSeaGreen*              = 0AAB220H;
  clWebPaleTurquoise*              = 0EEEEAFH;
  clWebLightCyan*                  = 0FFFFE0H;
  clWebLightBlue*                  = 0E6D8ADH;
  clWebLightSkyBlue*               = 0FACE87H;
  clWebCornFlowerBlue*             = 0ED9564H;
  clWebDarkBlue*                   = 08B0000H;
  clWebIndigo*                     = 082004BH;
  clWebMediumTurquoise*            = 0CCD148H;
  clWebTurquoise*                  = 0D0E040H;
  clWebCyan*                       = 0FFFF00H;
  clWebAqua*                       = 0FFFF00H;
  clWebPowderBlue*                 = 0E6E0B0H;
  clWebSkyBlue*                    = 0EBCE87H;
  clWebRoyalBlue*                  = 0E16941H;
  clWebMediumBlue*                 = 0CD0000H;
  clWebMidnightBlue*               = 0701919H;
  clWebDarkTurquoise*              = 0D1CE00H;
  clWebCadetBlue*                  = 0A09E5FH;
  clWebDarkCyan*                   = 08B8B00H;
  clWebTeal*                       = 0808000H;
  clWebDeepskyBlue*                = 0FFBF00H;
  clWebDodgerBlue*                 = 0FF901EH;
  clWebBlue*                       = 0FF0000H;
  clWebNavy*                       = 0800000H;

  clWebDarkViolet*                 = 0D30094H;
  clWebDarkOrchid*                 = 0CC3299H;
  clWebMagenta*                    = 0FF00FFH;
  clWebFuchsia*                    = 0FF00FFH;
  clWebDarkMagenta*                = 08B008BH;
  clWebMediumVioletRed*            = 08515C7H;
  clWebPaleVioletRed*              = 09370DBH;
  clWebBlueViolet*                 = 0E22B8AH;
  clWebMediumOrchid*               = 0D355BAH;
  clWebMediumPurple*               = 0DB7093H;
  clWebPurple*                     = 0800080H;
  clWebDeepPink*                   = 09314FFH;
  clWebLightPink*                  = 0C1B6FFH;
  clWebViolet*                     = 0EE82EEH;
  clWebOrchid*                     = 0D670DAH;
  clWebPlum*                       = 0DDA0DDH;
  clWebThistle*                    = 0D8BFD8H;
  clWebHotPink*                    = 0B469FFH;
  clWebPink*                       = 0CBC0FFH;

  clWebLightSteelBlue*             = 0DEC4B0H;
  clWebMediumSlateBlue*            = 0EE687BH;
  clWebLightSlateGray*             = 0998877H;
  clWebWhite*                      = 0FFFFFFH;
  clWebLightgrey*                  = 0D3D3D3H;
  clWebGray*                       = 0808080H;
  clWebSteelBlue*                  = 0B48246H;
  clWebSlateBlue*                  = 0CD5A6AH;
  clWebSlateGray*                  = 0908070H;
  clWebWhiteSmoke*                 = 0F5F5F5H;
  clWebSilver*                     = 0C0C0C0H;
  clWebDimGray*                    = 0696969H;
  clWebMistyRose*                  = 0E1E4FFH;
  clWebDarkSlateBlue*              = 08B3D48H;
  clWebDarkSlategray*              = 04F4F2FH;
  clWebGainsboro*                  = 0DCDCDCH;
  clWebDarkGray*                   = 0A9A9A9H;
  clWebBlack*                      = 0000000H;

VAR
  clSystemColor*,clScrollBar*,clBackground*,clActiveCaption*,
  clInactiveCaption*,clMenu*,clWindow*,clWindowFrame*,clMenuText*,
  clWindowText*,clCaptionText*,clActiveBorder*,clInactiveBorder*,
  clAppWorkSpace*,clHighlight*,clHighlightText*,clBtnFace*,
  clBtnShadow*,clGrayText*,clBtnText*,clInactiveCaptionText*,
  clBtnHighlight*,cl3DDkShadow*,cl3DLight*,clInfoText*,clInfoBk*: W.COLORREF;

PROCEDURE FillInt*(destAdr, size, filler: Integer);
CODE {SYSTEM.i386}
  MOV   EDI, destAdr[EBP]
  MOV	ECX, size[EBP]
  MOV	EAX, filler[EBP]
  TEST  ECX, 3
  JZ	ok
  PUSH  8
  INT	3
ok:
  SHR	ECX, 2
  CLD
  REP	STOSD
END FillInt;

PROCEDURE ConvertBGRA*(rgba: Integer):Integer;
BEGIN
  RETURN SYSTEM.LSH(ASH(rgba, 24), -24) * 10000H+
         SYSTEM.LSH(ASH(rgba, 16), -24) *   100H+
	 SYSTEM.LSH(ASH(rgba,  8), -24);
END ConvertBGRA;

TYPE
  TCanvas* = POINTER TO RECORD
    handle*         : W.HDC;
    color*          : Integer;
    left*           : Integer;
    top*            : Integer;
    width*          : Integer;
    height*         : Integer;

    parent          : W.HWND;
    hMemDc          : W.HDC;
    hMemBmp         : W.HBITMAP;
    pointer         : W.ADDRESS;
    paintstruct     : W.PAINTSTRUCT;
    BI              : W.BITMAPINFO;

    PROCEDURE & Create* (ParentHandle: W.HWND);
    BEGIN
      ASSERT(ParentHandle > 0,100);
      parent := ParentHandle;
      GetBInfo;
    END Create;

    PROCEDURE GetBInfo;
    BEGIN
      BI.bmiHeader.biSize        := SIZE(W.BITMAPINFOHEADER);
      BI.bmiHeader.biWidth       := width;
      BI.bmiHeader.biHeight      := -height;
      BI.bmiHeader.biPlanes      := 1;
      BI.bmiHeader.biBitCount    := 32;
      BI.bmiHeader.biCompression := W.BI_RGB;
    END GetBInfo;

    PROCEDURE BeginPaint*;
    VAR
      rect: W.RECT;
    BEGIN
      W.GetClientRect(parent,rect);
      left   := rect.left;
      top    := rect.top;
      width  := rect.right-rect.left;
      height := rect.bottom-rect.top;
      BI.bmiHeader.biWidth       := width;
      BI.bmiHeader.biHeight      := -height;
      handle:= W.BeginPaint(parent,paintstruct);
      hMemDc  := W.CreateCompatibleDC(handle);
      W.DeleteObject(hMemBmp);
      hMemBmp:=W.CreateDIBSection(handle, BI, W.DIB_RGB_COLORS,pointer, 0, 0);
      W.SelectObject(hMemDc, hMemBmp);
      W.SetBkMode(handle,W.TRANSPARENT);

      FillInt(pointer,width*height*4,ConvertBGRA(color));

    END BeginPaint;

    PROCEDURE EndPaint*;
    BEGIN
      W.BitBlt(handle,left,top,width,height,hMemDc,0,0,W.SRCCOPY);
      (*W.StretchBlt(handle,left,top,width,height,hMemDc,0,0,320,16,W.SRCCOPY);*)
      pointer:=-1;
      W.DeleteObject(hMemBmp);
      W.DeleteDC(hMemDc);
      W.EndPaint(parent,paintstruct);
      W.ReleaseDC(handle,parent);
    END EndPaint;

    PROCEDURE Draw* (X,Y: Integer; image: I.TGraphics);
    VAR
      x,y: Integer;
      pix: Integer;
    BEGIN
      IF image = NIL THEN RETURN END;
      FOR x:=0 TO image.width-1 DO
        FOR y:=0 TO image.height-1 DO
          IF (x+X>=0) & (x+X<width) & (y+Y>=0) & (y+Y<height) THEN
            SYSTEM.GET(image.pointer+(x+y*image.width)*image.bitsize,pix);
            IF pix # image.magic THEN
              SYSTEM.PUT(pointer+(X+Y*width)*image.bitsize+(x+y*width)*image.bitsize,pix);
            END;
          END;
        END;
      END;
    END Draw;

  END;

BEGIN
  clScrollBar                     := W.GetSysColor(W.COLOR_SCROLLBAR);
  clBackground                    := W.GetSysColor(W.COLOR_BACKGROUND);
  clActiveCaption                 := W.GetSysColor(W.COLOR_ACTIVECAPTION);
  clInactiveCaption               := W.GetSysColor(W.COLOR_INACTIVECAPTION);
  clMenu                          := W.GetSysColor(W.COLOR_MENU);
  clWindow                        := W.GetSysColor(W.COLOR_WINDOW);
  clWindowFrame                   := W.GetSysColor(W.COLOR_WINDOWFRAME);
  clMenuText                      := W.GetSysColor(W.COLOR_MENUTEXT);
  clWindowText                    := W.GetSysColor(W.COLOR_WINDOWTEXT);
  clCaptionText                   := W.GetSysColor(W.COLOR_CAPTIONTEXT);
  clActiveBorder                  := W.GetSysColor(W.COLOR_ACTIVEBORDER);
  clInactiveBorder                := W.GetSysColor(W.COLOR_INACTIVEBORDER);
  clAppWorkSpace                  := W.GetSysColor(W.COLOR_APPWORKSPACE);
  clHighlight                     := W.GetSysColor(W.COLOR_HIGHLIGHT);
  clHighlightText                 := W.GetSysColor(W.COLOR_HIGHLIGHTTEXT);
  clBtnFace                       := W.GetSysColor(W.COLOR_BTNFACE);
  clBtnShadow                     := W.GetSysColor(W.COLOR_BTNSHADOW);
  clGrayText                      := W.GetSysColor(W.COLOR_GRAYTEXT);
  clBtnText                       := W.GetSysColor(W.COLOR_BTNTEXT);
  clInactiveCaptionText           := W.GetSysColor(W.COLOR_INACTIVECAPTIONTEXT);
  clBtnHighlight                  := W.GetSysColor(W.COLOR_BTNHIGHLIGHT);
  cl3DDkShadow                    := W.GetSysColor(W.COLOR_3DDKSHADOW);
  cl3DLight                       := W.GetSysColor(W.COLOR_3DLIGHT);
  clInfoText                      := W.GetSysColor(W.COLOR_INFOTEXT);
  clInfoBk                        := W.GetSysColor(W.COLOR_INFOBK);
END Graphics.
